/* Sistemas Integrados TECNISA

Nome: 0147_GERTRG_DTULTATU_SEGMERCADO.SQL

Descrio:

Atualiza a data de ultima atualizao da tabela SEGMERCADO

Criao:
09/09/2003 Alexis Tolentino
*/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_SEGMERCADO' and
            type = 'TR'                    and
            u.uid = o.uid                  and
            u.name = USER)
  DROP TRIGGER DTULTATU_SEGMERCADO
  GO

CREATE TRIGGER DTULTATU_SEGMERCADO
ON SEGMERCADO
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'SEGMERCADO', 'CDSEGMER=' + CDSEGMER+';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE SEGMERCADO
      SET  DTULTATUSEGM = GETDATE()
      FROM INSERTED
      WHERE ISNULL(SEGMERCADO.CDSEGMER,0) = ISNULL(INSERTED.CDSEGMER,0);
   END;
END;
GO

